Considerater = LibStub("AceAddon-3.0"):NewAddon("Considerater", "AceConsole-3.0")

--[[
local statNames = {
["EMPTY_SOCKET_RED"] = {},
["EMPTY_SOCKET_YELLOW"] = {},
["EMPTY_SOCKET_BLUE"] = {},
["EMPTY_SOCKET_META"] = {},

["IGNORE_ARMOR"] = {}, 
["THREAT_MOD"] = {}, 
["STEALTH_LEVEL"] = {}, 
["MELEE_DMG"] = {}, 
["RANGED_DMG"] = {}, 
["MOUNT_SPEED"] = {}, 
["RUN_SPEED"] = {}, 

["STR"] = {}, 
["AGI"] = {}, 
["STA"] = {}, 
["INT"] = {}, 
["SPI"] = {}, 
["ARMOR"] = {}, 
["ARMOR_BONUS"] = {}, 

["FIRE_RES"] = {}, 
["NATURE_RES"] = {}, 
["FROST_RES"] = {}, 
["SHADOW_RES"] = {}, 
["ARCANE_RES"] = {}, 

["FISHING"] = {}, 
["MINING"] = {}, 
["HERBALISM"] = {}, 
["SKINNING"] = {}, 

["BLOCK_VALUE"] = {}, 

["AP"] = {}, 
["RANGED_AP"] = {}, 
["FERAL_AP"] = {}, 
["AP_UNDEAD"] = {}, 
["AP_DEMON"] = {}, 

["HEAL"] = {}, 

["SPELL_DMG"] = {}, 
["SPELL_DMG_UNDEAD"] = {}, 
["SPELL_DMG_DEMON"] = {}, 
["HOLY_SPELL_DMG"] = {}, 
["FIRE_SPELL_DMG"] = {}, 
["NATURE_SPELL_DMG"] = {}, 
["FROST_SPELL_DMG"] = {}, 
["SHADOW_SPELL_DMG"] = {}, 
["ARCANE_SPELL_DMG"] = {}, 

["SPELLPEN"] = {}, 

["HEALTH"] = {}, 
["MANA"] = {}, 
["HEALTH_REG"] = {}, 
["MANA_REG"] = {}, 

["MAX_DAMAGE"] = {}, 
["DPS"] = {}, 

["DEFENSE_RATING"] = {}, 
["DODGE_RATING"] = {}, 
["PARRY_RATING"] = {}, 
["BLOCK_RATING"] = {}, 
["MELEE_HIT_RATING"] = {}, 
["RANGED_HIT_RATING"] = {}, 
["SPELL_HIT_RATING"] = {}, 
["MELEE_HIT_AVOID_RATING"] = {}, 
["RANGED_HIT_AVOID_RATING"] = {}, 
["SPELL_HIT_AVOID_RATING"] = {}, 
["MELEE_CRIT_RATING"] = {}, 
["RANGED_CRIT_RATING"] = {}, 
["SPELL_CRIT_RATING"] = {}, 
["MELEE_CRIT_AVOID_RATING"] = {}, 
["RANGED_CRIT_AVOID_RATING"] = {}, 
["SPELL_CRIT_AVOID_RATING"] = {}, 
["RESILIENCE_RATING"] = {}, 
["MELEE_HASTE_RATING"] = {}, 
["RANGED_HASTE_RATING"] = {}, 
["SPELL_HASTE_RATING"] = {}, 
["DAGGER_WEAPON_RATING"] = {}, 
["SWORD_WEAPON_RATING"] = {}, 
["2H_SWORD_WEAPON_RATING"] = {}, 
["AXE_WEAPON_RATING"] = {}, 
["2H_AXE_WEAPON_RATING"] = {}, 
["MACE_WEAPON_RATING"] = {}, 
["2H_MACE_WEAPON_RATING"] = {}, 
["GUN_WEAPON_RATING"] = {}, 
["CROSSBOW_WEAPON_RATING"] = {}, 
["BOW_WEAPON_RATING"] = {}, 
["FERAL_WEAPON_RATING"] = {}, 
["FIST_WEAPON_RATING"] = {}, 
["STAFF_WEAPON_RATING"] = {}, 
["EXPERTISE_RATING"] = {}, 
["ARMOR_PENETRATION_RATING"] = {}, 
}
--]]

local options = {
  name = "Considerater",
  handler = Considerater,
  type = 'group',
  args = {},
}


local defaultRestoDruidProfile = {
  ["SPI"] = 8,
  ["INT"] = 6,
  ["STA"] = 4,
  ["SPELL_DMG"] = 18.8,
  ["MANA_REG"] = 24,
}

local defaultCatDruidProfile = {
  ["STR"] = 2.266,
  ["AGI"] = 2.812,
  ["MELEE_HASTE_RATING"] = 1.443,
  ["MELEE_CRIT_RATING"] = 1.676,
  ["MELEE_HIT_RATING"] = 2.07,
  ["AP"] = 1,
  ["FERAL_AP"] = 1,
  ["ARMOR_PENETRATION_RATING"] = 2.247,
  ["EXPERTISE_RATING"] = 2.096,
}

local defaultBearDruidProfile = {
  ["STA"] = 4.33,
  ["AGI"] = 6.79,
  ["ARMOR"] = 0.59,
  ["DEFENSE_RATING"] = 2.79,
  ["DODGE_RATING"] = 4.43,
  ["EXPERTISE_RATING"] = 1.69,
}

local defaultBalanceDruidProfile = {
  ["SPELL_CRIT_RATING"] = 15,
  ["INT"] = 6,
  ["STA"] = 4,
  ["SPELL_DMG"] = 18.8,
  ["MANA_REG"] = 10,
}

local defaultProfiles = { 
  ["Resto Druid"] = defaultRestoDruidProfile,
  ["Cat Druid"] = defaultCatDruidProfile,
  ["Bear Druid"] = defaultBearDruidProfile,
  ["Balance Druid"] = defaultBalanceDruidProfile,
}

local defaultActiveProfiles = {
  "Resto Druid", 
  "Cat Druid", 
  "Bear Druid",
  "Balance Druid",
}

local defaults = {
  profile = {
    profiles = defaultProfiles,
  },
  char = {
    cachedItems = {}, 
    activeProfiles = defaultActiveProfiles,
  },
}

function Considerater:OnInitialize()
  self.db = LibStub("AceDB-3.0"):New("ConsideraterDB", defaults, "Default")
  if not self.db.profile.profiles then
    self.db.profile.profiles = defaultProfiles
  end
  LibStub("AceConfig-3.0"):RegisterOptionsTable("Considerater", options)
  self:RegisterChatCommand("consider", "ChatCommand")
  self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Considerater", "Considerater")
  test1 = self:ScoreItem(43180,"Resto Druid")
end

function Considerater:ChatCommand(input)
  if not input or input:trim() == "" then
    InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
  else
    -- LibStub("AceConfigCmd-3.0").HandleCommand(Considerater, "consider", "Considerater", input)
    self:ConsiderCmd(input)
  end
end

function Considerater:ConsiderCmd(arg)
  local sum = StatLogic:GetSum(arg)
  if sum then
    local topScores = self:Consider(arg)
    for profile,data in pairs(topScores) do
      if data["link"] == sum["link"] then
        self:Print(profile..": "..data["link"].." has top score = "..data["score"])
      end
    end
  end
end

function Considerater:OnEnable()
end

function Considerater:OnDisable()
end

-- Score an item (link) by a profile (name)
function Considerater:ScoreItem(item, profile)
  local sumTable = StatLogic:GetSum(item)
  local profTable = self.db.profile.profiles[profile]
  local sum = 0
  if sumTable and profTable then
    for k,v in pairs(sumTable) do
      if type(v) == "number" then
        local w = profTable[k]
        if w then
          sum = sum + v * w
        end
      end
    end
  end
  return sum
end

function Considerater:Consider(item) 
  local topScores = {}
  local loc = self:GetItemEquipLoc(item)
  for i,profile in ipairs(self.db.char.activeProfiles) do
    local score = self:ScoreItem(item,profile)
    topScores[profile] = {
      ["score"] = score,
      ["link"] = item,
      ["itemScore"] = score,
    }
  end
  for i,bag in ipairs(self.db.char.cachedItems) do
    for j,slot in ipairs(bag) do
      if slot["loc"] == loc then
        for profile,score in pairs(slot["scores"]) do
          if score > topScores[profile]["score"] then
            -- new top score found
            topScores[profile]["score"] = score
            topScores[profile]["link"] = slot["link"]
          end
        end
      end
    end
  end
  return topScores
end

function Considerater:ScoreCachedItems()
  for i,bag in ipairs(self.db.char.cachedItems) do
    for j,slot in ipairs(bag) do
      for i,profile in ipairs(self.db.char.activeProfiles) do
        slot["scores"][profile] = self:ScoreItem(slot["link"],profile)
      end
    end
  end
end

function Considerater:SaveItems()
  if not self.db.char.cachedItems then
    self.db.char.cachedItems = {}
  end
  -- use "virtual bag indexing" based around the helper functions at the bottom
  -- of this file
  for bag = 0,self:GetMaxBagNum() do
    local numSlots = self:GetMaxSlotNum(bag)
    if numSlots and numSlots > 0 then
      -- Only cache bags which are openable at this time
      for slot = 1,numSlots do
        local item = self:GetBagSlotItemLink(bag,slot)
        if item then
          local loc = self:GetItemEquipLoc(item)
          if loc and loc ~= "" then
            if not self.db.char.cachedItems[bag] then
              -- Create table for bag if it does not exist
              self.db.char.cachedItems[bag] = {}
            end
            -- Save it
            self.db.char.cachedItems[bag][slot] = { 
              ["link"] = item,
              ["loc"] = loc,
              ["scores"] = {},
            }
          end
        end
      end
    end
  end
  self:ScoreCachedItems()
end

function Considerater:ResetProfiles()
  self.db.profile.profiles = defaultProfiles
  self.db.char.activeProfiles = defaultActiveProfiles
end

function Considerater:GetItemEquipLoc(item)
  local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(item)
  return itemEquipLoc
end

function Considerater:GetMaxBagNum()
  -- Map inventory (equipped stuff) to 0
  -- Map blizzard bag -1 "main bank slots" to 1
  -- Map blizzard bags 0-4 "carried bags" to 2-6
  -- Map blizzard bags 5-11 "bank bags" to 7-13
  return 13
end

function Considerater:GetMaxSlotNum(i)
  if i == 0 then
    return 18
  elseif i == 1 then
    return GetContainerNumSlots(-1)
  elseif i >= 2 and i <= 13 then
    return GetContainerNumSlots(i - 2)
  else
    return 0
  end
end

function Considerater:GetBagSlotItemLink(i,slot)
  if i == 0 then
    return GetInventoryItemLink("player",slot)
  elseif i == 1 then
    return GetContainerItemLink(-1,slot)
  elseif i >= 2 and i <= 13 then
    return GetContainerItemLink(i - 2,slot)
  else
    return nil
  end
end

